<template>
  <div>
    <div class="row">
      <div class="col-xs-8 flex">
        <div class="route-icon">
          <i
            style="font-size:28px; color:#0242AD"
            class="icon tractor-semi-trailer-refrizhirator-tent-b"
          ></i>
        </div>
        <div class="route-info">
          <div class="__way">{{ data.departureLocation.title || 'Не указано' }} → {{ data.arrivalLocation.title || 'Не указано' }}</div>
          <div class="__item" v-if="data.service">
            {{ data.service.resourceSpeciesTitle }}
            {{ data.service.resourceSubtypeTitle }}
            {{ data.service.resourcePatternParameter }}
          </div>
        </div>
      </div>
      <div class="col-xs-4">
        <span class="price-tip">
          Все цены
          <br />указаны без НДС
        </span>
      </div>
    </div>

    <div class="row">
      <div class="col-xs-4">
        <ob-input
          label="Экспертный тариф"
          type="money:2"
          subTitle="₽"
          :value="expertTotal"
          disabled
        />
      </div>
      <div class="col-xs-4">
        <ob-input
          label="Цена за км"
          subTitle="₽/км"
          type="money:2"
          :value="rateData.priceKm"
          @input="updateExpertPrice('priceKm', $event)"
          ref="priceKm"
        />
      </div>
      <div class="col-xs-4">
        <ob-input
          label="Расстояние"
          subTitle="км"
          type="number:strict"
          :value="rateData.distance"
          @input="updateExpertPrice('distance', $event)"
          ref="distance"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-8">
        <ob-input type="date" label="Назначен" icon="calendar" :value="introduceAt" disabled />
      </div>
    </div>

    <ob-modal
      ref="viewHistory"
      title="История изменения БЦ"
      size="medium"
      custom-class="modal-medium"
      :is-read-only="true"
      :is-show-controls="true"
    >
      <history-modal />
    </ob-modal>
  </div>
</template>

<script>
import ObInput from 'common-components/src/obComponents/obInput';
import ObModal from 'common-components/src/obComponents/obModal';
import HistoryModal from '../HistoryModal';

function padNum(n) {
  return `0${n}`.slice(-2);
}

export default {
  name: 'ExpertModalContent',
  components: {
    ObInput,
    HistoryModal,
    ObModal,
  },
  props: {
    data: {
      type: Object,
      default: () => ({}),
    },
    rateData: {
      type: Object,
      default: () => ({}),
    },
    introduced: {
      default: () => '',
    },
  },
  computed: {
    expertTotal() {
      if (
        this.rateData.priceStage === '' ||
        typeof this.rateData.priceStage === 'undefined'
      ) {
        return '';
      }
      return this.rateData.priceStage;
    },
    introduceAt() {
      if (this.introduced) {
        const date = new Date(this.introduced);
        return `${padNum(date.getDate())}.${padNum(
          date.getMonth() + 1
        )}.${date.getFullYear()}`;
      }
      return '';
    },
  },
  methods: {
    updateExpertPrice(type, value) {
      const input = this.$refs[type].$el.querySelector('input');

      if (!value && input.value) {
        return;
      }

      const newRate = {
        ...this.rateData,
        [type]: +value,
      };
      newRate.priceStage = newRate.priceKm * newRate.distance;

      this.$emit('expertChanged', newRate);
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '~common-components/src/static/css/mixins';
.flex {
  display: flex;
  align-items: center;
  .route-icon {
    margin-right: 13px;
  }
  .route-info {
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.4px);
    text-transform: uppercase;
  }
}
.price-tip {
  display: block;
  margin-left: auto;
  @include font-mixin(12px, 14px, 400, $gray-slate, 0.4px);
  text-transform: uppercase;
  text-align: right;
}
</style>
